-module(stack).
-compile(export_all).
-author('hanak@iit.bme.hu, modified by: kapolnai@iit.bme.hu').
-vsn('$LastChangedDate: 2011-11-13 18:26:21 +0100 (v, 13 nov 2011) $$').

% @type stack() = empty | {any(),stack()}

% Üres verem.
empty() -> empty.

% empty(S) igaz, ha S üres.
is_empty(empty) -> true;
is_empty({_,_}) -> false.

% push(X, S) az X elem az S tetejére helyezéséből keletkező verem.
push(X, empty)     -> {X,empty};
push(X, {_X,_S}=S) -> {X,S}.

% @spec pop(S) -> {X,S1}.
% Az S verem tetején lévő X elemet eltávolítva marad S1 verem.
pop(empty) -> error;
pop({X,S}) -> {X,S}.

% to_list(S) az S verem elemeit tartalmazó lista LIFO sorrendben.
to_list(empty) -> [];
to_list({X,S}) -> [X|to_list(S)].

test(1) ->
%    push(1,push(2,push(3,empty())));
    S1 = stack:push(1,stack:empty()),
    S2 = stack:push(2,S1),
    S3 = stack:push(3,S2),
    S3;
% szöveget megfordít.
test(2) ->
    Stack = lists:foldl(fun stack:push/2, stack:empty(), "szoveg"),
    to_list(Stack).

%% % @spec print(Stack) -> none().
%% % Kiírja a kimenetre a Stack tartalmát.
%% print(empty) ->
%%     io:format("empty~n");
%% print({X,S}) ->
%%     io:format("~p,", [X]),
%%     print(S).

